import { ChangeDetectorRef, EventEmitter, OnChanges, OnInit, SimpleChanges, TemplateRef } from '@angular/core';
import { FormControl } from '@angular/forms';
import { NzTableQueryParams } from 'ng-zorro-antd/table';
import { DataTableColumn, DataTableColumnFormatType, DataTableFilter, FetchRecordsEvent } from './data-table.model';
import { NzI18nService } from 'ng-zorro-antd/i18n';
import * as i0 from "@angular/core";
export declare class DataTableComponent implements OnInit, OnChanges {
    private cdr;
    private i18n;
    columns: DataTableColumn[];
    records: any[];
    showDownloadButton: boolean;
    downloadFileName: string;
    displaySizeOptions: any;
    totalRecordsCount: number;
    pageSize: number;
    filterList: DataTableFilter[];
    label: string;
    loading: boolean;
    selectable: boolean;
    selectedRecordsSet: Set<any>;
    readonly: boolean;
    customCellTemplateRef?: TemplateRef<void> | TemplateRef<any>;
    customNoDataTemplateRef?: TemplateRef<void> | TemplateRef<any>;
    searchable: boolean;
    fetchRecords: EventEmitter<FetchRecordsEvent>;
    selectRecord: EventEmitter<any>;
    readonly dataTableColumnFormatType: typeof DataTableColumnFormatType;
    readonly PAGE_SIZE_OPTIONS: any;
    currentPageIndex: number;
    searchControl: FormControl;
    sortedColumn: DataTableColumn | undefined;
    constructor(cdr: ChangeDetectorRef, i18n: NzI18nService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    reset(force?: boolean): void;
    clearSearch(): void;
    showNoDataView(): boolean;
    updateCheckedSet(id: number, checked: boolean): void;
    onAllChecked(checked: boolean): void;
    onItemChecked(id: number, checked: boolean): void;
    onQueryParamsChange(params: NzTableQueryParams): void;
    downloadCsv(): void;
    private _subscribeToSearchControlChanges;
    private _resetPagination;
    private _fetchRecords;
    static ɵfac: i0.ɵɵFactoryDeclaration<DataTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DataTableComponent, "x-data-table", never, { "columns": { "alias": "columns"; "required": false; }; "records": { "alias": "records"; "required": false; }; "showDownloadButton": { "alias": "showDownloadButton"; "required": false; }; "downloadFileName": { "alias": "downloadFileName"; "required": false; }; "displaySizeOptions": { "alias": "displaySizeOptions"; "required": false; }; "totalRecordsCount": { "alias": "totalRecordsCount"; "required": false; }; "pageSize": { "alias": "pageSize"; "required": false; }; "filterList": { "alias": "filterList"; "required": false; }; "label": { "alias": "label"; "required": false; }; "loading": { "alias": "loading"; "required": false; }; "selectable": { "alias": "selectable"; "required": false; }; "selectedRecordsSet": { "alias": "selectedRecordsSet"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "customCellTemplateRef": { "alias": "customCellTemplateRef"; "required": false; }; "customNoDataTemplateRef": { "alias": "customNoDataTemplateRef"; "required": false; }; "searchable": { "alias": "searchable"; "required": false; }; }, { "fetchRecords": "fetchRecords"; "selectRecord": "selectRecord"; }, never, never, false, never>;
}
