import { Observable } from 'rxjs';
import { HttpResponse } from '../models/common.model';
export interface DataTableRecords {
    items: any[];
    totalCount: number;
}
export interface DataTableColumn {
    name: string;
    field: string;
    width: string | null;
    sort: boolean;
    sortOrder: string | null;
    format?: DataTableColumnFormat;
    headerClass?: string | null;
    cellClass?: string | null;
}
export interface DataTableService {
    getAll(): Observable<DataTableRecords>;
    getOne(id: number): Observable<HttpResponse>;
    create(payload: any): Observable<HttpResponse>;
    update(id: number, payload: any): Observable<HttpResponse>;
    delete(id: number): Observable<HttpResponse>;
}
export interface DataTableFilter {
    name: string;
    value: any;
    operation: string;
}
export interface PaginationInfo {
    pageNumber?: number;
    pageSize: number;
}
export interface FetchRecordsEvent {
    searchKey?: string;
    sortOrder?: string;
    sortField?: string;
    paginationInfo?: PaginationInfo;
    filterList?: DataTableFilter[];
}
export interface DataTableColumnFormat {
    type: DataTableColumnFormatType;
    [key: string]: any;
}
export declare enum DataTableColumnFormatType {
    date = "date",
    boolean = "boolean",
    label = "label",
    statusToggle = "statusToggle",
    nestedAttribute = "nestedAttribute",
    menuDropdownActions = "menuDropdownActions",
    templateRef = "templateRef",
    contacts = "contacts"
}
